unit U_ZZJWLOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxBarBuiltInMenu,
  RM_BarCode, cxContainer, cxMaskEdit, dxSkinsCore, dxSkinsDefaultPainters,
  dxSkinscxPCPainter;

type
  TfrmZZJWLOutList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    SPName: TEdit;
    FactoryName: TEdit;
    SPID: TEdit;
    CYENAME: TEdit;
    CRType: TComboBox;
    Label9: TLabel;
    SPCODE: TEdit;
    TBZF: TToolButton;
    cxTabControl1: TcxTabControl;
    Label6: TLabel;
    Label7: TLabel;
    llPerson: TEdit;
    llDepartment: TEdit;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1CRType: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    ToolButton1: TToolButton;
    ADOPrint: TADOQuery;
    Panel2: TPanel;
    Edit2: TEdit;
    Label10: TLabel;
    Edit3: TEdit;
    Label11: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label13: TLabel;
    SPHX: TEdit;
    Tv1Column6: TcxGridDBColumn;
    RMBarCodeObject1: TRMBarCodeObject;
    Tv1Column7: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Label14: TLabel;
    JWLTYPE: TComboBox;
    Tv1Column11: TcxGridDBColumn;
    Tv1Column12: TcxGridDBColumn;
    ToolButton2: TToolButton;
    Tv1Column13: TcxGridDBColumn;
    Label15: TLabel;
    orderno: TEdit;
    Tv1Column14: TcxGridDBColumn;
    Label16: TLabel;
    JWLLABNAME: TcxButtonEdit;
    Tv1Column15: TcxGridDBColumn;
    Button3: TButton;
    Tv1Column16: TcxGridDBColumn;
    Label17: TLabel;
    tpno: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure SPIDChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure CYENAMEChange(Sender: TObject);
    procedure TBZFClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure cxButtonEdit1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Tv1CustomDrawIndicatorCell(Sender: TcxGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxCustomGridIndicatorItemViewInfo; var ADone: Boolean);
  private
    canshu1, canshu2: string;
    procedure InitGrid();
    { Private declarations }
  public
    FFSPID: string;
    { Public declarations }
  end;

//var
 // frmShaOutList: TfrmShaOutList;

implementation

uses
  U_DataLink, U_RTFun, U_ShaOutPut, u_fun, U_ZDYHelp;

{$R *.dfm}

procedure TfrmZZJWLOutList.FormDestroy(Sender: TObject);
begin
  //frmShaOutList:=nil;
end;

procedure TfrmZZJWLOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmZZJWLOutList.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  EndDate.DateTime := SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 90;
end;

procedure TfrmZZJWLOutList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
//      SQL.Add(',CYMJID=(select CYMJID FROM fl_ydang B WHERE B.CYID=A.CYID )');
      SQL.Add(',CYMJID=(select CYID FROM fl_ydang B WHERE B.CYmjID=A.CYID )');
      sql.Add(',cyename=(select CYENAME FROM fl_ydang B WHERE B.CYmjID=A.CYID)');
      sql.Add(' ,RKprice=(select  price from CK_SXPB_CR X where X.spid=A.FZSPID)');
      sql.Add(' ,RKMoney= A.qty*(select  price from CK_SXPB_CR X where X.spid=A.FZSPID)');
      sql.Add(' from CK_SXPB_CR A');
      sql.add(' where A.CRTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
      sql.Add(' and A.CRTime<''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
      sql.Add(' and isnull(CKName,'''')=''机物料''');
      SQL.Add(' and CRFlag=''出库''  ');
      if cxTabControl1.TabIndex = 0 then
      begin
        Sql.Add(' and ZFFlag=0 ');
      end
      else if cxTabControl1.TabIndex = 1 then
      begin
        Sql.Add(' and ZFFlag=1 ');
      end;
      if Trim(Self.Caption) = '机物料出库管理' then
      begin
        Sql.Add(' and Filler=' + quotedstr(Trim(DName)));
      end;
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmZZJWLOutList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmZZJWLOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmZZJWLOutList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('机物料出库列表', Tv1, '机物料仓库');
  Close;
end;

procedure TfrmZZJWLOutList.FormShow(Sender: TObject);
begin
  if Trim(Self.Caption) = '机物料出库管理' then
  begin
    TBEdit.Visible := true;
    TBDel.Visible := true;
    TBZF.Visible := true;
  end
  else if Trim(Self.Caption) = '机物料出库查询' then
  begin
    TBAdd.Visible := False;
    TBDel.Visible := False;
    TBEdit.Visible := False;
    TBZF.Visible := False;
    cxTabControl1.Visible := False;
  end;
  ReadCxGrid('机物料出库列表', Tv1, '机物料仓库');
  if Trim(FFSPID) <> '' then
  begin
    TBAdd.Visible := False;
    TBDel.Visible := False;
    TBEdit.Visible := False;
    TBZF.Visible := False;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered := False;
        Close;
        sql.Clear;
        sql.Add(' select A.* ');
        sql.Add(' from CK_SXPB_CR A');
        sql.Add(' where A.FZSPID=''' + Trim(FFSPID) + '''');
        SQL.Add(' and CRFlag=''出库''  ');
        SQL.Add(' and isnull(CKName,'''')=''机物料'' ');
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain, CDS_Main);
      SInitCDSData20(ADOQueryMain, CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end;
  end;
  //InitGrid();
end;

procedure TfrmZZJWLOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel('机物料出库列表', cxGrid2);
end;

procedure TfrmZZJWLOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmZZJWLOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmZZJWLOutList.SPIDChange(Sender: TObject);
begin
  if Length(Trim(SPID.Text)) < 4 then
  begin
    if Trim(SPID.Text) <> '' then
      Exit;
  end;
  TBFind.Click;
end;

procedure TfrmZZJWLOutList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmZZJWLOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmZZJWLOutList.TBDelClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
  begin

    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
        sql.Add(' Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID and A.ZFFlag=0)');
        sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID and A.ZFFlag=0 )');
        sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('FZSPID').AsString) + '''');
        ExecSQL;
      end;
      ADOQueryCmd.Connection.CommitTrans;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!', '提示', 0);
    end;
  end;
  CDS_Main.Delete;
end;

procedure TfrmZZJWLOutList.TBAddClick(Sender: TObject);
begin
  try
    frmShaOutPut := TfrmShaOutPut.Create(Application);
    with frmShaOutPut do
    begin
      FBCId := '';
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmShaOutPut.Free;
  end;
end;

procedure TfrmZZJWLOutList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  try
    frmShaOutPut := TfrmShaOutPut.Create(Application);
    with frmShaOutPut do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('SPID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmShaOutPut.Free;
  end;

end;

procedure TfrmZZJWLOutList.CYENAMEChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmZZJWLOutList.TBZFClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
  begin

    if Application.MessageBox('确定要作废数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' UPdate CK_SXPB_CR Set ZFFlag=1,ZFTime=Getdate(),ZFPerson=''' + Trim(DName) + '''');
        sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');

        sql.Add(' Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID and A.ZFFlag=0)');
        sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID and A.ZFFlag=0 )');
        sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('FZSPID').AsString) + '''');
        ExecSQL;
      end;
      ADOQueryCmd.Connection.CommitTrans;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('作废异常!', '提示', 0);
    end;
  end;
  CDS_Main.Delete;
end;

procedure TfrmZZJWLOutList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmZZJWLOutList.ToolButton1Click(Sender: TObject);
begin
  panel2.Visible := True;
  Edit2.Text := Trim(CDS_Main.fieldbyname('piqty').AsString);
end;

procedure TfrmZZJWLOutList.Button1Click(Sender: TObject);
var
  fPrintFile: string;
  EngMoney: string;
  Porderno, LBName, SYRName: string;
  i, j: Integer;
  OrderKg: Double;
  FDate: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
  FLABNAME: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if Edit2.Text = '' then
  begin
    application.MessageBox('每箱盒数不能为空！', '提示信息', MB_ICONERROR);
    Exit;
  end;
  if Edit3.Text = '' then
  begin
    application.MessageBox('打印份数不能为空！', '提示信息', MB_ICONERROR);
    Exit;
  end;
  if JWLLABNAME.Text = '' then
  begin
    FLABNAME := '机物料出库单';
  end
  else
  begin
    FLABNAME := JWLLABNAME.Text;
  end;
  ExportFtErpFile(FLABNAME + '.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\' + FLABNAME + '.rmf';

  with ADOPrint do
  begin
    Close;
    sql.Clear;
    SQL.Add('select *,cyename=(select CYENAME FROM fl_ydang B WHERE B.CYmjID=A.CYID)');
    SQL.Add(',CYCF=(select CYCF FROM fl_ydang B WHERE B.CYmjID=A.CYID) from ck_sxpb_cr A where spid=' + QUOTEDSTR(Trim(CDS_Main.fieldbyname('spid').AsString)));

    Open;

  end;

  if FileExists(fPrintFile) then
  begin
    RMVariables['SL'] := Trim(Edit2.text);
    RMVariables['CYMJID'] := CDS_Main.FIELDBYNAME('CYMJID').AsString;
//
//    //RMVariables['enddate']:=enddate.DateTime;
//    try
//      Moudle := LoadLibrary('MakeQRBarcode.dll');
//      @Makebar := GetProcAddress(Moudle, 'Make');
//      @Mixtext := GetProcAddress(Moudle, 'MixText');
//      Txt := Trim((trim(CDS_Main.fieldbyname('spid').AsString)));
//      fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
//      if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
//        CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
//      if FileExists(fImagePath) then
//        DeleteFile(fImagePath);
//      Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
//    except
//      application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
//      exit;
//    end;
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowPrintDialog := False;
    RMVariables['QRBARCODE'] := fImagePath;
    Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1);
    RM1.PrintReport;
  end
  else
  begin
    Application.MessageBox(PChar('没有找' + fPrintFile), '提示', 0);
  end;
end;

procedure TfrmZZJWLOutList.Button2Click(Sender: TObject);
begin
  Panel2.Visible := False;
end;

procedure TfrmZZJWLOutList.ToolButton2Click(Sender: TObject);
var
  fPrintFile: string;
  EngMoney: string;
  Porderno, LBName, SYRName: string;
  i, j: Integer;
  OrderKg: Double;
  FDate: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
  wsql: string;
begin
  if CDS_Main.IsEmpty then
    Exit;

  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('物料出库单.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\物料出库单.rmf';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin

    wsql := ' ';
    First;
    while not Eof do
    begin
      if CDS_Main.fieldbyname('SSEL').AsBoolean then
      begin
        if wsql = ' ' then
          wsql := wsql + quotedstr(trim(Trim(CDS_Main.fieldbyname('spid').AsString)))
        else
          wsql := wsql + ',' + quotedstr(trim(Trim(CDS_Main.fieldbyname('spid').AsString)));

      end;
      Next;

      CDS_Main.EnableControls;
    end;
    wsql := '(' + wsql + ')';
//    wsql := wsql + ')';
    CDS_Main.DisableControls;
  end;
  CDS_Main.EnableControls;
  with ADOPrint do
  begin
    Close;
    sql.Clear;
    SQL.Add('select *,cyename=(select CYENAME FROM fl_ydang B WHERE B.CYID=A.CYID) from ck_sxpb_cr A where spid in' + (Trim(wsql)));
    SQL.Add('ORDER BY ORDERNO,CYENAME,SPHX');
//    ShowMessage(SQL.Text);
    Open;
  end;

  if FileExists(fPrintFile) then
  begin
//    RMVariables['SL'] := Trim(Edit2.text);

    RM1.LoadFromFile(fPrintFile);
    RMVariables['QRBARCODE'] := fImagePath;
//    Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1);
    RM1.ShowPrintDialog := True;
    RM1.SHOWReport;
  end
  else
  begin
    Application.MessageBox(PChar('没有找' + fPrintFile), '提示', 0);
  end;
end;

procedure TfrmZZJWLOutList.cxButtonEdit1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'JWLLABNAME';
      flagname := '机物料标签名';
      if ShowModal = 1 then
      begin

        JWLLABNAME.text := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);

      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmZZJWLOutList.Button3Click(Sender: TObject);
var
  fPrintFile: string;
  EngMoney: string;
  Porderno, LBName, SYRName: string;
  i, j: Integer;
  OrderKg: Double;
  FDate: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
  FLABNAME: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if Edit2.Text = '' then
  begin
    application.MessageBox('每箱盒数不能为空！', '提示信息', MB_ICONERROR);
    Exit;
  end;
//  if Edit3.Text = '' then
//  begin
//    application.MessageBox('打印份数不能为空！', '提示信息', MB_ICONERROR);
//    Exit;
//  end;
  if JWLLABNAME.Text = '' then
  begin
    FLABNAME := '机物料出库单';
  end
  else
  begin
    FLABNAME := JWLLABNAME.Text;
  end;
  ExportFtErpFile(FLABNAME + '.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\' + FLABNAME + '.rmf';

  with ADOPrint do
  begin
    Close;
    sql.Clear;
    SQL.Add('select *,cyename=(select CYENAME FROM fl_ydang B WHERE B.CYmjID=A.CYID)');
    SQL.Add(',CYCF=(select CYCF FROM fl_ydang B WHERE B.CYmjID=A.CYID) from ck_sxpb_cr A where spid=' + QUOTEDSTR(Trim(CDS_Main.fieldbyname('spid').AsString)));

    Open;

  end;

  if FileExists(fPrintFile) then
  begin
    RMVariables['SL'] := Trim(Edit2.text);
    RMVariables['CYMJID'] := CDS_Main.FIELDBYNAME('CYMJID').AsString;
//
//    //RMVariables['enddate']:=enddate.DateTime;
//    try
//      Moudle := LoadLibrary('MakeQRBarcode.dll');
//      @Makebar := GetProcAddress(Moudle, 'Make');
//      @Mixtext := GetProcAddress(Moudle, 'MixText');
//      Txt := Trim((trim(CDS_Main.fieldbyname('spid').AsString)));
//      fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
//      if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
//        CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
//      if FileExists(fImagePath) then
//        DeleteFile(fImagePath);
//      Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
//    except
//      application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
//      exit;
//    end;
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowPrintDialog := False;
    RMVariables['QRBARCODE'] := fImagePath;
    Rm1.DefaultCopies := StrToIntDef(Edit3.Text, 1);
    RM1.ShowReport;
  end
  else
  begin
    Application.MessageBox(PChar('没有找' + fPrintFile), '提示', 0);
  end;
end;

procedure TfrmZZJWLOutList.Tv1CustomDrawIndicatorCell(Sender: TcxGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxCustomGridIndicatorItemViewInfo; var ADone: Boolean);
var
  FValue: string;
  FBounds: TRect;
begin
  FBounds := AViewInfo.Bounds;
  if (AViewInfo is TcxGridIndicatorRowItemViewInfo) then
  begin
    ACanvas.FillRect(FBounds);
    ACanvas.DrawComplexFrame(FBounds, clBtnHighlight, clBtnShadow, [bBottom, bLeft, bRight], 1);
    FValue := IntToStr(TcxGridIndicatorRowItemViewInfo(AViewInfo).GridRecord.Index + 1);
    InflateRect(FBounds, -1, -1);    //Platform   specific.   May   not   work   on   Linux.
    ACanvas.Font.Color := clBlack;
    ACanvas.Brush.Style := bsClear;
    ACanvas.DrawText(FValue, FBounds, cxAlignCenter or cxAlignTop);
    ADone := True;
  end;
end;

end.

